<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <base-searchbar
      :filter-by="filterList"
      :filter-count="1"
      title="Backup &amp; Restore"
      icon="mdi-book-open-page-variant"
      show-add-filter
      @trigger="$trigger"
      @refresh="bootstrap"
    >
      <template v-slot:body>
        <v-btn
          color="primary"
          @click="backup"
        >
          Backup
        </v-btn>
      </template>
    </base-searchbar>

    <v-card>
      <v-data-table
        :headers="backupHeader"
        :items="backupList"
        class="elevation-1"
        :loading="dataStatus.backupsTable.loading"
      >
        <template #item.created_at="{ item }">
          {{ item.created_at | $humanDate }}
        </template>

        <template #item.actions="{ item }">
          <v-btn
            small
            color="primary"
            class="mr-2"
            @click="handleRestore({ item })"
          >
            Restore
          </v-btn>

          <v-btn
            small
            color="red white--text"
            @click="handleDeleteBackup({ item })"
          >
            Delete
          </v-btn>
        </template>
      </v-data-table>
    </v-card>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import _get from 'lodash/get'

export default {
  name: 'AdminBackup',

  data: () => ({
    filterList: ['sample'],

    backupHeader: [
      { text: 'Name', value: 'filename' },
      { text: 'Definition', value: 'definition' },
      { text: 'Date Created', value: 'created_at' },
      { text: 'Actions', value: 'actions', width: 300 }
    ],

    dataStatus: {
      backupsTable: { loading: true }
    },

    modals: {}
  }),

  computed: {
    ...mapState('backup', {
      backupList: 'backupList'
    })
  },

  watch: {
    async $route (data) {
      await this.bootstrap({ ...data.query })
    }
  },

  async created () {
    await this.bootstrap()
  },

  methods: {
    ...mapActions('backup', {
      backupDatabase: 'backupDatabase',
      getBackupList: 'getBackupList',
      restore: 'restore',
      deleteBackup: 'deleteBackup'
    }),

    bootstrap (payload) {
      const config = {
        loading: 'dataStatus.backupsTable.loading'
      }

      this.statusWrapper(async () => {
        await this.getBackupList()
      }, config)
    },

    handleRestore ({ item }) {
      const success = async () => {
        try {
          await this.restore({ backupID: item.id })
          await this.bootstrap()
          this.$setAlert({ type: 'success' })
        } catch (error) {
          this.$setAlert({ type: 'error' })
        }
      }

      this.$prompt({ success })
    },

    handleDeleteBackup ({ item }) {
      const success = async () => {
        try {
          await this.deleteBackup({ backupID: item.id })
          await this.bootstrap()
          this.$setAlert({ type: 'success' })
        } catch (error) {
          this.$setAlert({ type: 'error' })
        }
      }

      this.$prompt({ success })
    },

    async backup () {
      const swalResponse = await this.$swal.fire({
        title: 'Backup definition',
        input: 'text',
        showCancelButton: true,
        inputValidator: value => {
          if (!value) {
            return 'You need to write something!'
          }
        }
      })

      if (swalResponse.value) {
        try {
          await this.backupDatabase({
            definition: swalResponse.value
          })

          await this.bootstrap()
          this.$setAlert({ type: 'success', text: 'Backup successfully created' })
        } catch (error) {
          const text = _get(error, 'response.data.message')
          this.$setAlert({ type: 'error', text })
        }
      }
    }
  }
}
</script>
